package com.tecnavia.tabridge;

import android.app.Application;
import android.content.Context;

import androidx.appcompat.app.AppCompatDelegate;

import com.facebook.soloader.SoLoader;
import com.tecnavia.tabridge.utils.TaReflection;

public abstract class TaApplication extends Application {
	@Override
	public void onCreate() {
		super.onCreate();
		SoLoader.init(this, false);
		TaReflection.addShareInterface(this);
		TaContext.init(this);
	}

	@Override
	protected void attachBaseContext(Context base) {
		super.attachBaseContext(base);
		disableDarkMode();
	}

	/**
	 * login, editions, help pages doesn't work with dark mode
	 * because some devices (redmi, xiaomi etc..) apply wrong color to webview
	 * call this method before onCreate to avoid that a recreation is called by system
	 * because the method trigger uiMode change
	 */
	public void disableDarkMode(){
		AppCompatDelegate.setDefaultNightMode(AppCompatDelegate.MODE_NIGHT_NO);
	}

	/**
	 * @return authority provider declared inside manifest
	 * required to enable share of file such as pdf
	 */
	public String getFileProviderAuthority(){
		return "";
	}


}
