package com.tecnavia.tabridge;

import com.facebook.react.ReactPackage;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.uimanager.ViewManager;
import com.tecnavia.tabridge.modules.ActivityStarterModule;
import com.tecnavia.tabridge.modules.NotificationsModule;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class TaBridgePackage implements ReactPackage {

  @Override
  public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
    return Arrays.<ViewManager>asList();
  }

  @Override
  public List<NativeModule> createNativeModules(
                              ReactApplicationContext reactContext) {
    List<NativeModule> modules = new ArrayList<>();
    modules.add(new ActivityStarterModule(reactContext));
    modules.add(new NotificationsModule(reactContext));

    return modules;
  }

}
