package com.tecnavia.tabridge;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;

import com.tecnavia.tabridge.broadcasts.TaReceiver;

public class TaKeyUtils {
	/**
	 * send event with all active pressed keys
	 */
	public static void sendKeysEvent(Activity activity, String eventName, KeyEvent event) {
		try {
			Intent i = new Intent();
			i.setAction(eventName);
			i.putExtra(TaReceiver.BUNDLE_EXTRA, getKeysBundle(event));
			activity.sendBroadcast(i);
		} catch (NullPointerException e){
			e.printStackTrace();
		}
	}

	/**
	 * make a bundle with thew following structure
	 * {
	 *     label: X,
	 *     number: 1,
	 *     characters: XXXX,
	 *     downTime: long,
	 *     eventTime: long,
	 *     keyCode: keyCode...1,
	 *     unicodeChar: 0,
	 *     repeatCount: 0
	 * }
	 */
	private static Bundle getKeysBundle(KeyEvent event){
		Bundle keyMap = new Bundle();
		try{
			keyMap.putString("label", String.valueOf(event.getDisplayLabel()));
		} catch (Exception ignore){}
		keyMap.putString("number", String.valueOf(event.getNumber()));
		keyMap.putString("characters", event.getCharacters());
		keyMap.putDouble("downTime", event.getDownTime());
		keyMap.putDouble("eventTime", event.getEventTime());
		keyMap.putInt("keyCode", event.getKeyCode());
		keyMap.putInt("unicodeChar", event.getUnicodeChar());
		keyMap.putInt("repeatCount", event.getRepeatCount());
		return keyMap;
	}
}
