package com.tecnavia.tabridge.hacks;

import android.content.Context;
import android.content.res.Configuration;
import android.util.Log;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Arrays;

public class BaseReflection {
	protected static void invoke(String packageName, String methodName, Class<?>[] paramsType, Object[] params){
		Class<?> c = getInstance(packageName);
		try {
			Method method = c.getMethod(methodName, paramsType);
			method.invoke(null, params);
			Log.d("Reflection", methodName + " invoked");
			Log.d("Reflection", "with params type: " + Arrays.toString(paramsType));
		} catch (NullPointerException | IllegalAccessException | NoSuchMethodException | InvocationTargetException e) {
			Log.d("Reflection", methodName + " > not found or went in error: " + e.getMessage());
		}
	}

	protected static Class<?> getInstance(String packageName){
		Class<?> c = null;
		try {
			c = Class.forName(packageName);
			Log.d("Reflection", packageName + "class found");
		} catch (ClassNotFoundException e) {
			Log.d("Reflection", "class not found: " + e.getMessage());
		}
		return c;
	}
}
