package com.tecnavia.tabridge.listeners;

import android.os.Bundle;

public interface ActivityStarterModuleListener {
    /**
     * used to reload react native context
     */
    void onReload();
    /**
     * @return action mode visible state
     */
    boolean isActionModeVisible();
    /**
     * @return prop to initialize react native
     */
    Bundle getInitProps();
    /**
     * @return true if onClose action is consumed otherwise react native consume it
     */
    boolean handleClose();

    /**
     * @return true if url is opened outside reactive otherwise false leave rn to manage the url
     */
    boolean handleOpenUrl(String url);

    /**
     * @return true to consume analytics event, false otherwise
     */
    boolean handleTrackAction(Bundle data);

    /**
     * @return true to consume token expired event, false otherwise
     */
    boolean handleTokenExpired();
}
