package com.tecnavia.tabridge.listeners;

import android.os.Bundle;

import java.io.Serializable;

public abstract class TaFragmentDelegate {
	public abstract void recreate();
	
	/**
	 * @return action mode visible state
	 */
	public boolean isActionModeVisible(){
		return false;
	}
	
	/**
	 * @return true if onClose action is consumed otherwise react native consume it
	 */
	public boolean handleClose(){
		return false;
	}

	/**
	 * @return true if url is opened outside reactive otherwise false leave rn to manage the url
	 */
	public boolean handleOpenUrl(String url){
		return false;
	}

	/**
	 * @return true to consume analytics event, false otherwise
	 */
	public boolean handleTrackAction(Bundle data){
		return false;
	}

	/**
	 * @return true to consume token expired event, false otherwise
	 */
	public boolean handleTokenExpired(){
		return false;
	}
}
