package com.tecnavia.tabridge.utils;

import android.content.Context;
import android.content.res.AssetManager;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class TaAssets {
    public static void copyFileOrDir(Context context, String path, String destination) throws Exception {
        AssetManager assetManager = context.getAssets();
        String[] assets;
        assets = assetManager.list(path);
        if (assets.length == 0) {
            copyFile(context, path, destination);
        } else {
            String fullPath = destination + "/" + path;
            File dir = new File(fullPath);
            if (!dir.exists())
                dir.mkdir();
            for (int i = 0; i < assets.length; ++i) {
                copyFileOrDir(context, path + "/" + assets[i], destination);
            }
        }
    }

    private static void copyFile(Context context, String filename, String destination) throws Exception{
        AssetManager assetManager = context.getAssets();
        InputStream in = null;
        OutputStream out = null;
        Exception exception = null;
        try {
            in = assetManager.open(filename);
            String newFileName = destination + "/" + filename;
            out = new FileOutputStream(newFileName);

            byte[] buffer = new byte[1024];
            int read;
            while ((read = in.read(buffer)) != -1) {
                out.write(buffer, 0, read);
            }
        } catch (Exception e) {
            exception = e;
        } finally {
            if(in != null){
                try {
                    in.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if(out != null) {
                try {
                    out.flush();
                    out.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        if(exception != null){
            throw exception;
        }
    }
}
