package com.tecnavia.tabridge.utils;

import android.util.Log;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

public class TaFile {
    /**
     * @param name path
     * @return true if the file exist
     */
    public static boolean exists( String name ){
        File f = new File( name );
        return f.exists( );
    }

    /**
     * delete folder and all content, use apache file utils library
     *
     * @param folder folder path
     * @return true if folder is deleted correctly
     */
    public static boolean deleteFolder( String folder ){
        return clearFolder(folder);
    }

    public static boolean clearFolder( String path ){
        try{
            File parent = new File( path );
            if(parent.isFile()){
                parent.delete();
                return true;
            }
            File[] files = parent.listFiles();
            if( files != null && files.length > 0){
                for( File file : files ){
                    if(!file.isFile()){
                        clearFolder(file.getPath());
                    }
                    file.delete();
                }
            }
            return true;
        }
        catch( Exception e ){
            e.printStackTrace( );
            return false;
        }
    }

    public static String getExtension(String fileName){
        String extension = "";
        int i = fileName.lastIndexOf('.');
        int p = Math.max(fileName.lastIndexOf('/'), fileName.lastIndexOf('\\'));
        if (i > p) {
            extension = fileName.substring(i+1);
        }
        return extension;
    }

    public static void scanFolder(File filesDir, List<File> foundFiles) {
        try{
            if(foundFiles == null){
                foundFiles = new ArrayList<>();
            }
            if(filesDir != null){
                if(filesDir.isDirectory()){
                    Log.d("FILE_UTILS", filesDir.getPath());
                    File[] files = filesDir.listFiles();
                    if(files != null) {
                        for (File child : files) {
                            scanFolder(child, foundFiles);
                        }
                    }
                } else {
                    foundFiles.add(filesDir);
                    Log.d("FILE_UTILS", filesDir.getPath());
                }
            } else {
                Log.d("FILE_UTILS", "file is null");
            }
        }catch (Exception e){
            if(filesDir != null) {
                Log.d("FILE_UTILS", "something went wrong with: " + filesDir.toString());
            }
        }
    }
}