"use strict";

function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * This exposes the native ActivityStarter module as a JS module.
 */
import { NativeModules, Platform } from "react-native";
import PropTypes from "prop-types";
import { JSUtils } from "@tecnavia/react-native-utils";
const {
  ActivityStarter
} = NativeModules;
export const DescendantFocusability = {
  block: "blockDescendants",
  before: "beforeDescendants",
  after: "afterDescendants"
};
let OurBridge = /*#__PURE__*/function () {
  function OurBridge() {
    _classCallCheck(this, OurBridge);
  }
  return _createClass(OurBridge, null, [{
    key: "setCustomNativeProps",
    value:
    /**
     * allow to set custom android xml attribute
     * @param {*} ref
     * @param {*} customProps
     */
    async function setCustomNativeProps(ref, customProps = {}) {
      if (OurBridge.isAndroid()) {
        try {
          await ActivityStarter.setCustomNativeProps({
            ...customProps,
            tag: JSUtils.getViewByRef(ref)
          });
        } catch (e) {}
      }
    }

    /**
     * allow to set custom android xml attribute
     * @param {*} ref
     * @param {*} customProps
     */
  }, {
    key: "setCustomOnTouch",
    value: async function setCustomOnTouch(ref, params = {}) {
      if (OurBridge.isAndroid()) {
        try {
          await ActivityStarter.setCustomOnTouch({
            ...params,
            tag: JSUtils.getViewByRef(ref)
          });
        } catch (e) {}
      }
    }
  }, {
    key: "isAndroid",
    value: function isAndroid() {
      return Platform.OS === "android";
    }
  }, {
    key: "saveBundleName",
    value: async function saveBundleName(bundleName, bundleAppVersion) {
      return ActivityStarter.saveBundleName(bundleName, bundleAppVersion);
    }
  }, {
    key: "resetBundleName",
    value: async function resetBundleName() {
      return ActivityStarter.saveBundleName("", "");
    }
  }, {
    key: "getBundleName",
    value: async function getBundleName() {
      return ActivityStarter.getBundleName();
    }
  }, {
    key: "restartReactContext",
    value: async function restartReactContext() {
      return ActivityStarter.restartReactContext();
    }
  }, {
    key: "isActionModeVisible",
    value: async function isActionModeVisible() {
      if (OurBridge.isAndroid()) {
        try {
          const {
            result
          } = await ActivityStarter.isActionModeVisible();
          return result;
        } catch (e) {
          console.debug(e.message);
        }
      }
      return false;
    }
  }, {
    key: "initializeGlobals",
    value: function initializeGlobals() {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.initializeGlobals();
      }
      return Promise.resolve();
    }
  }, {
    key: "assetsCopy",
    value: async function assetsCopy(src, destination) {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.assetsCopy(src, destination);
      }
      return Promise.resolve();
    }
  }, {
    key: "getBase64FromRes",
    value: async function getBase64FromRes(name) {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.getBase64FromRes(name);
      }
      return Promise.resolve();
    }
  }, {
    key: "getStatusBarOrientation",
    value: async function getStatusBarOrientation() {
      if (!OurBridge.isAndroid()) {
        return ActivityStarter.getStatusBarOrientation();
      }
      return Promise.resolve();
    }
  }, {
    key: "isOrientationLocked",
    value: async function isOrientationLocked() {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.isOrientationLocked();
      }
      return Promise.resolve();
    }
  }, {
    key: "dispatchTap",
    value: async function dispatchTap(tag, x, y) {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.dispatchTap(tag, x, y);
      }
      return Promise.resolve();
    }
  }, {
    key: "onClose",
    value: async function onClose() {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.onClose();
      }
      return Promise.resolve(false);
    }
  }, {
    key: "onTrackAction",
    value: async function onTrackAction(data) {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.onTrackAction(data);
      }
      return Promise.resolve(false);
    }
  }, {
    key: "willOpenURL",
    value: async function willOpenURL(url) {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.willOpenURL(url);
      }
      return Promise.resolve(false);
    }
  }, {
    key: "onTokenExpired",
    value: async function onTokenExpired() {
      if (OurBridge.isAndroid()) {
        return ActivityStarter.onTokenExpired();
      }
      return Promise.resolve(false);
    }
  }]);
}();
_defineProperty(OurBridge, "customPropTypes", {
  descendantFocusability: PropTypes.oneOf([DescendantFocusability.block, DescendantFocusability.before, DescendantFocusability.after]),
  focusableInTouchMode: PropTypes.bool,
  focus: PropTypes.bool
});
_defineProperty(OurBridge, "customDefaultProps", {
  focusableInTouchMode: true,
  focusable: true
});
export { OurBridge as default };
//# sourceMappingURL=OurNativeBridge.js.map